// 简单起见, 此处使用变量存储token信息
// 实际项目中可存储于浏览器端本地存储, 如localStorage, sessionStorage, cookie
let token = {}

// 获取服务端信息
document.getElementById('btn-get-message').onclick = async function () {
    try {
        // 这里将token放入header带到服务端
        // 按惯例授权信息放入header的Authorization字段, 并用Bearer标识后面的token携带的是发送人的信息
        const resp = await axios.post('/getMessage', null, {
            headers: { Authorization: 'Bearer ' + token.accessToken }
        })
        document.getElementById('output-area').value = resp.data
    } catch (e) {
        alert(e.message)
    }
}

// 登录
document.getElementById('btn-login').onclick = async function () {
    try {
        // 将用户名'zhangsan'作为登录信息上行至服务端进行登录
        // 简单起见, 本例未做用户登录界面, 使用26行的数据模拟登录信息
        // 注意这里的post请求是发送向鉴权服务(authServer的9000端口)
        const resp = await axios.post('http://localhost:9000/login', {
            username: 'zhangsan', password: '1234'
        })
        // 暂存服务器端返回的token, 以供后续业务使用(第11行)
        token = resp.data
        alert('登录成功, 现在获取信息试试...')
    } catch (e) {
        alert(e)
    }
}

// 刷新accessToken
document.getElementById('btn-refresh-token').onclick = async function () {
    try {
        const resp = await axios.post('http://localhost:9000/token', {
            token: token.refreshToken
        })
        token.accessToken = resp.data.accessToken
        alert('AccessToken已刷新')
    } catch (e) {
        alert(e)
    }
}

// 退出登录
document.getElementById('btn-logout').onclick = async function () {
    try {
        await axios.delete('http://localhost:9000/logout', {
            data: { token: token.refreshToken }
        })
        alert('已退出登录')
    } catch (e) {
        alert(e)
    }
}